moDraw.bga = {};

function moDraw.bga:setOpenPDA(self)
	local slotName = moGuiMiniPDAsetGet.slot[moGuiMiniPDAsetGet.slotOpen];
	if slotName == "silageSilos" and moBgaMapObjects.silo == 0 then
		moGuiMiniPDAsetGet.slotOpen = 0;
		g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['silageSilosNO'.. moDefault.language]), 2500);
		return;
	end;
	if slotName == "bga" and moBgaMapObjects.catcher == 0 then
		moGuiMiniPDAsetGet.slotOpen = 0;
		g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['bgaNO'.. moDefault.language]), 2500);
		return;
	end;	
	local openSwitchStatus = moGuiMiniPDAsetGet.slotSwitch[moGuiMiniPDAsetGet.slotOpen];	
	local fixDifferenz = 0.007+moSetGetGui.pdaMenueSize/2;
	local posBbga = moSetGetGui.pdaMenueSize/3*(37+moSetGetGui.screenAspectRatio)*1.03;	
	local posY = moGuiMiniPDAsetGet.slotOpenY[moGuiMiniPDAsetGet.slotOpen];
	local posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8);
	if moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen] > 0.5 then posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8)-(posBbga);end;
	local posH = moSetGetGui.pdaMenuePosHeight;
	local firstPosXY = posY-(moSetGetGui.pdaMenueSize/1.17);	
	local firstLetter = 0.003;
	function nextLine(posNew, setLine, half)
		if setLine then			
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-moSetGetGui.pdaMenueLineDif, firstPosXY-moSetGetGui.pdaMenueLineDif-0.002, posBbga-fixDifferenz, 0.001);
			moSetGetGui["designLine"]:render();
		end;
		firstPosXY = firstPosXY-(moSetGetGui.pdaMenueSize+posNew);
		posH = posH+moSetGetGui.pdaMenueSize+posNew;
		posY = posY-(moSetGetGui.pdaMenueSize+posNew);		
	end;	
	function setCatcherBgaExtensionValues1(a, name)
		if not moBgaMapObjects["catcher".. a].objCreate.fermenter_bioOK then setTextColor(unpack(moGuiMiniPDAsetGet.warningColor3));end;				
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, a.. ".".. name.. "(".. tostring(moBgaMapObjects["catcher".. a].speed).. ")");
		nextLine(0.0015);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(unpack(moLanguage.extern['generator'.. moDefault.language])));		
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		local kw = string.format("%.1f", Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.printPower,0));
		renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(kw).. " kw");
		setTextAlignment(false);
		nextLine(0.0015);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(unpack(moLanguage.extern['feedingrate'.. moDefault.language])));		
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		local rate = string.format("%.1f", Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.bunkerFeedFactor,0)*100);
		renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(rate).. "%");
		setTextAlignment(false);
		
		nextLine(0.0025);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(unpack(moLanguage.extern['bunker'.. moDefault.language])));
	end;
	function setCatcherBgaExtensinoValues2(a)
		nextLine(0.0025);			
		setTextBold(true);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(unpack(moLanguage.extern['bunker'.. moDefault.language])).. "-TS");
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		local prozent = string.format("%.2f", Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.bunker_TS,0)*100);
		renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(prozent).. "%");		
		setTextAlignment(false);
		nextLine(0.0015);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(unpack(moLanguage.extern['fermenting'.. moDefault.language])).. "-TS");
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		prozent = string.format("%.2f", Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.fermenterTS,0)*100);
		renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(prozent).. "%");		
		setTextAlignment(false);
		nextLine(0.0025);			
		if moBgaMapObjects["catcher".. a].objCreate.BGA_Bonus == 0 then --not moBgaMapObjects["catcher".. a].objCreate.bonusFillLevel
			setTextColor(unpack(moGuiMiniPDAsetGet.warningColor3));
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(unpack(moLanguage.extern['guelleBonusNO'.. moDefault.language])));
		else
			setTextBold(false);
			setTextColor(unpack(moGuiMiniPDAsetGet.warningColor0));
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(unpack(moLanguage.extern['guelleBonus'.. moDefault.language])));
			setTextBold(false);
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			fillLevel = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.BGA_Bonus,0));
			capacity = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.BGA_Bonus_Capacity,0));
			renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(capacity).. "(".. tostring(fillLevel).. ")L");
			setTextAlignment(false);
		end;
	end;
	setTextBold(true);
	moSetGetGui["designGround"]:render();	
	function setBgas()
		if slotName == "bga" and moBgaMapObjects.catcher > 0 or moGuiMiniPDAsetGet.combiBgaSilo and moBgaMapObjects.catcher > 0 then
			function getBgaLength()
				if moGuiMiniPDAsetGet.combiBgaSilo then return 1, 4;end;
				if moBgaMapObjects.catcher > 4 and tonumber(openSwitchStatus) == 2 then return 5, 8;end;
				if moBgaMapObjects.catcher > 8 and tonumber(openSwitchStatus) == 3 then return 9, 12;end;
				if moBgaMapObjects.catcher > 12 and tonumber(openSwitchStatus) == 4 then return 13, 16;end;		
				return 1, 4;
			end;
			local firstBgaDisplay, maxBgaDisplay = getBgaLength();
			local tempBgaDisplay = 0;
			moSetGetBga:setBgaUpdate(self, 1);
			setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));	
			renderText(posX+(firstLetter), firstPosXY, moSetGetGui.pdaMenueSize, "BGA(s):");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moBgaMapObjects.catcher));		
			setTextAlignment(false);
			nextLine(0.005, true);
			for a=1, moBgaMapObjects.catcher do
				tempBgaDisplay = tempBgaDisplay+1;
				if tonumber(tempBgaDisplay) >= tonumber(firstBgaDisplay) then					
					if tonumber(firstBgaDisplay) > tonumber(maxBgaDisplay) then break;end;
					firstBgaDisplay = firstBgaDisplay+1;
					setTextBold(true);
					--setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
					setTextColor(unpack(moGuiMiniPDAsetGet.warningColor1));		
					local bgaName = moBgaMapObjects["catcher".. a].bgaName;		
					if moBgaMapObjects["catcher".. a].bgaExtension then --if moBgaMapObjects.bgaExtension and moBgaMapObjects["bgaExtension"..a] ~= nil then 
						setCatcherBgaExtensionValues1(a, bgaName)
					else
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, a.. ".".. tostring(bgaName).. "(".. tostring(moBgaMapObjects["catcher".. a].speed).. ")");
						nextLine(0.0015);
						setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "Catcher");
					end;		
					setTextBold(false);		
					setTextAlignment(RenderText.ALIGN_RIGHT);
					setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
					local fillLevel = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["catcher".. a].fillLevel,0));
					local capacity = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["catcher".. a].capacity,0));
					--local fillLevel = string.format("%0.0f", Utils.getNoNil(moBgaMapObjects["catcher".. a].fillLevel, 0));
					renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(capacity).. " (".. tostring(fillLevel).. ")L");		
					setTextAlignment(false);
					nextLine(0.0015);		
					setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
					local stringLength = 0.010/3*(string.len(moBgaMapObjects["catcher".. a].fillType))*1.03;
					if posBbga >= stringLength then								
						if stringLength == 0 then
							renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, tostring("unknow"));
						else
							renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, tostring(moBgaMapObjects["catcher".. a].fillType));
						end;
					else
						local splitNames = Utils.splitString(" ", moBgaMapObjects["catcher".. a].fillType)
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, "too long(".. (table.getn(splitNames)-1).. " fruit names)");
					end;		
					if moBgaMapObjects["catcher".. a].bgaExtension and moBgaMapObjects["catcher".. a].objCreate.fermenter_bioOK then --if moBgaMapObjects.bgaExtension and moBgaMapObjects["bgaExtension"..a] ~= nil and moBgaMapObjects["bgaExtension"..a].objCreate.fermenter_bioOK then
						setCatcherBgaExtensinoValues2(a)
					end;		
					nextLine(0.0025);
					setTextBold(true);
					setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
					renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moAnimalsTXT.liquidManure));
					setTextBold(false);
					setTextAlignment(RenderText.ALIGN_RIGHT);
					setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
					fillLevel = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["catcher".. a].liquidManureFillLevel,0));
					capacity = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["catcher".. a].liquidManureCapacity,0));
					--local fillLevel = string.format("%0.0f", Utils.getNoNil(moBgaMapObjects["catcher".. a].liquidManureFillLevel, 0));
					renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(capacity).. " (".. tostring(fillLevel).. ")L");				
					setTextAlignment(false);		
					nextLine(0.005, true)
				end;
			end;
		end;
	end;
	function setSilageSilos()
		if slotName == "silageSilos" and moBgaMapObjects.silo > 0 or moGuiMiniPDAsetGet.combiBgaSilo and moBgaMapObjects.silo > 0 then
			function getBgaSilosLength()
				if moGuiMiniPDAsetGet.combiBgaSilo then return 1, 7;end;
				if moBgaMapObjects.silo > 7 and tonumber(openSwitchStatus) == 2 then return 8, 14;end;
				if moBgaMapObjects.silo > 14 and tonumber(openSwitchStatus) == 3 then return 15, 21;end;
				if moBgaMapObjects.silo > 21 and tonumber(openSwitchStatus) == 4 then return 22, 28;end;
				if moBgaMapObjects.silo > 28 and tonumber(openSwitchStatus) == 5 then return 29, 35;end;
				if moBgaMapObjects.silo > 35 and tonumber(openSwitchStatus) == 6 then return 36, 42;end;
				return 1, 7;
			end;
			local firstBgaSilosDisplay, maxBgaSilosDisplay = getBgaSilosLength();
			local tempBgaSilosDisplay = 0;
			setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));	
			renderText(posX+(firstLetter), firstPosXY, moSetGetGui.pdaMenueSize, "Silo(s):");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moBgaMapObjects.silo));		
			setTextAlignment(false);
			moSetGetBga:setBgaUpdate(self, 2);
			nextLine(0.005, true);
			for a=1, moBgaMapObjects.silo do
				tempBgaSilosDisplay = tempBgaSilosDisplay+1;
				if tonumber(tempBgaSilosDisplay) >= tonumber(firstBgaSilosDisplay) then					
					if tonumber(firstBgaSilosDisplay) > tonumber(maxBgaSilosDisplay) then break;end;
					firstBgaSilosDisplay = firstBgaSilosDisplay+1;
					setTextBold(true);
					setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
					if moBgaMapObjects["silo".. a].siloName == nil then
						local siloType = " (unknow)";
						if moBgaMapObjects["silo".. a].movingPlanes <= 5 then siloType = " (small)";end;
						if moBgaMapObjects["silo".. a].movingPlanes > 5 and moBgaMapObjects["silo".. a].movingPlanes <= 10 then siloType = " (normal)";end;
						if moBgaMapObjects["silo".. a].movingPlanes > 10 and moBgaMapObjects["silo".. a].movingPlanes <= 15 then siloType = " (large)";end;
						if moBgaMapObjects["silo".. a].movingPlanes > 15 then siloType = " (big)";end;						
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "Silo ".. a.. tostring(siloType));						
					else
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moBgaMapObjects["silo".. a].siloName));
					end;
					setTextBold(false);
					setTextAlignment(RenderText.ALIGN_RIGHT);
					setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
					local fillLevel = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["silo".. a].fillLevel,0));
					local capacity = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["silo".. a].capacity,0));
					--local fillLevel = string.format("%0.0f", Utils.getNoNil(moBgaMapObjects["silo".. a].fillLevel, 0));
					renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(capacity).. " (".. tostring(fillLevel).. ")L");		
					--setTextAlignment(false);		
					local state = moBgaMapObjects["silo".. a].state;		
					if tonumber(state) == 2 then			
						setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
						local stringLength = 0.010/3*(string.len(moBgaMapObjects["silo".. a].fillType))*1.03;
						if posBbga >= stringLength then
							setTextColor(unpack(moGuiMiniPDAsetGet.warningColor0));
							if moBgaMapObjects.silageExtension then
								if tonumber(moBgaMapObjects["silo".. a].potatosFillLevel) > 0 then
									nextLine(0.0015);
									setTextAlignment(false);
									setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
									renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, unpack(moLanguage.extern['potatos'.. moDefault.language]));
									setTextAlignment(RenderText.ALIGN_RIGHT);
									setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
									local potatos = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].potatosFillLevel/fillLevel, 0)*100);
									renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(potatos).. "%");						
								end;
								if tonumber(moBgaMapObjects["silo".. a].grassFillLevel) > 0 then
									nextLine(0.0015);
									setTextAlignment(false);
									setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
									renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, unpack(moLanguage.extern['grass'.. moDefault.language]));
									setTextAlignment(RenderText.ALIGN_RIGHT);
									setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));						
									local grass = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].grassFillLevel/fillLevel, 0)*100);						
									renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(grass).. "%");						
								end;
								if tonumber(moBgaMapObjects["silo".. a].forageFillLevel) > 0 then
									nextLine(0.0015);
									setTextAlignment(false);
									setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
									renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, unpack(moLanguage.extern['forage'.. moDefault.language]));
									setTextAlignment(RenderText.ALIGN_RIGHT);
									setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
									local forage = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].forageFillLevel/fillLevel, 0)*100);
									renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(forage).. "%");						
								end;
								if not moBgaMapObjects["silo".. a].isRotten then
									nextLine(0.0015);
									renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, tostring(moBgaMapObjects["silo".. a].outPutFillType));
								else
									nextLine(0.0015);
									setTextAlignment(false)
									setTextColor(unpack(moGuiMiniPDAsetGet.warningColor3));
									local fillLevel1 = string.format("%0.1f", Utils.getNoNil(moBgaMapObjects["silo".. a].rottenFillLevel/moBgaMapObjects["silo".. a].fillLevel,0)*100);
									renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, unpack(moLanguage.extern['rotten'.. moDefault.language]).. " (".. fillLevel1.. "%)");
									setTextAlignment(RenderText.ALIGN_RIGHT);
									setTextColor(unpack(moGuiMiniPDAsetGet.warningColor0));
									renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, tostring(moBgaMapObjects["silo".. a].outPutFillType));
									setTextAlignment(false);
								end;
							else
								nextLine(0.0015);
								renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, tostring(moBgaMapObjects["silo".. a].fillType));
							end;
						else
							local splitNames = Utils.splitString(" ", moBgaMapObjects["silo".. a].fillType)
							renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, "too long(".. (table.getn(splitNames)-1).. " fruit names)");
						end;
					end;
					if tonumber(state) == 0 then			
						if tonumber(moBgaMapObjects["silo".. a].potatosFillLevel) > 0 then
							nextLine(0.0015);
							setTextAlignment(false);
							setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
							renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, unpack(moLanguage.extern['potatos'.. moDefault.language]));
							setTextAlignment(RenderText.ALIGN_RIGHT);
							setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
							local potatos = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].potatosFillLevel/fillLevel, 0)*100);
							renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(potatos).. "%");
							setTextAlignment(false);
						end;
						if tonumber(moBgaMapObjects["silo".. a].grassFillLevel) > 0 then
							nextLine(0.0015);
							setTextAlignment(false);
							setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
							renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, unpack(moLanguage.extern['grass'.. moDefault.language]));
							setTextAlignment(RenderText.ALIGN_RIGHT);
							setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
							local grass = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].grassFillLevel/fillLevel, 0)*100);
							renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(grass).. "%");
							setTextAlignment(false);
						end;			
						nextLine(0.0015);
						setTextAlignment(RenderText.ALIGN_RIGHT);
						setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));			
						local stringLength = 0.010/3*(string.len(moBgaMapObjects["silo".. a].fillType))*1.03;
						if posBbga >= stringLength then								
							renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, tostring(moBgaMapObjects["silo".. a].fillType));
						else
							local splitNames = Utils.splitString(" ", moBgaMapObjects["silo".. a].fillType)
							renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, "too long(".. (table.getn(splitNames)-1).. " fruit names)");
						end;
					end;
					setTextAlignment(false);		
					if tonumber(state) == 1 then			
						nextLine(0.0025);
						setTextBold(true);
						setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, unpack(moLanguage.extern['fermenting'.. moDefault.language]));
						setTextBold(false);
						setTextAlignment(RenderText.ALIGN_RIGHT);
						setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
						local fermenting = string.format("%0.1f", Utils.getNoNil(moBgaMapObjects["silo".. a].fermentingTime/moBgaMapObjects["silo".. a].fermentingDuration*100, 0));
						renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(fermenting).. "%");
						setTextAlignment(false);
					end;
					if tonumber(state) == 0 then
						nextLine(0.0025);
						setTextBold(true);
						setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['compact'.. moDefault.language]));
						setTextBold(false);
						setTextAlignment(RenderText.ALIGN_RIGHT);
						setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
						local compact = string.format("%0.1f", Utils.getNoNil(moBgaMapObjects["silo".. a].compactFillLevel/moBgaMapObjects["silo".. a].fillLevel*100, 0));
						renderText(posX+(posBbga/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(compact).. "%");
						setTextAlignment(false);			
					end;
					nextLine(0.005, true);
				end;
			end;
		end;
	end;
	if slotName == "bga" and not moGuiMiniPDAsetGet.combiBgaSilo then setBgas();end;
	if slotName == "silageSilos" and not moGuiMiniPDAsetGet.combiBgaSilo then setSilageSilos();end;
	if slotName == "bga" and moGuiMiniPDAsetGet.combiBgaSilo then setBgas();setSilageSilos();end;
	if slotName == "silageSilos" and moGuiMiniPDAsetGet.combiBgaSilo then setSilageSilos();setBgas();end;
	moSetGetGui:setOverlay(self, moSetGetGui["designGround"], posX-0.003, posY, posBbga-fixDifferenz+0.003, posH);	
	moGuiMiniPDAsetGet.slotOpenLastWidth[moGuiMiniPDAsetGet.slotOpen] = posBbga-fixDifferenz+0.003;
	moGuiMiniPDAsetGet.slotOpenLastHeight[moGuiMiniPDAsetGet.slotOpen] = posH;
	setTextBold(false);	
end;