moDrawCfg = {};

function moDrawCfg:dragDropUpdatePosMiniPDA(self, x, y, newRender)	
	if newRender then		
		moSetGetGui:setBackgroundColor(moSetGetGui["blank"], moGuiExtras.colors["green"]);		
		local checkPosX = x+moGuiMiniPDAsetGet.horizontal*(moGuiMiniPDAsetGet.slotsActive-1)+(moSetGetGui.buttonGfxWidth16*moGuiMiniPDAsetGet.zoomOutIn);
		--local checkPosY = y+moGuiMiniPDAsetGet.vertical*(moGuiMiniPDAsetGet.slotsActive-1)+(moSetGetGui.buttonGfxHeight16*moGuiMiniPDAsetGet.zoomOutIn);
		local checkPosY = y+moGuiMiniPDAsetGet.vertical+(moSetGetGui.buttonGfxHeight16*moGuiMiniPDAsetGet.zoomOutIn);
		if moGuiMiniPDAsetGet.alignment == 1 then
			checkPosX = x+moGuiMiniPDAsetGet.horizontal+(moSetGetGui.buttonGfxWidth16*moGuiMiniPDAsetGet.zoomOutIn);
			checkPosY = y-moGuiMiniPDAsetGet.vertical*(moGuiMiniPDAsetGet.slotsActive-1)+(moSetGetGui.buttonGfxHeight16*moGuiMiniPDAsetGet.zoomOutIn);
			if checkPosX > 1.0 or checkPosX < 0.0 or checkPosY > 1.0 or checkPosY <= 0.01 then
				moSetGetGui:setBackgroundColor(moSetGetGui["blank"], moGuiExtras.colors["red"]);			
			elseif checkPosX > 0.998 and checkPosX <= 1.00 or checkPosX > 0.0 and checkPosX <= 0.02 then
				moSetGetGui:setBackgroundColor(moSetGetGui["blank"], moGuiExtras.colors["yellow"]);
			end;
			if x > 0.992 or y > 0.992 then
				g_currentMission:showBlinkingWarning("!! intolerance position !!", 1500);
				moSetGetGui.dragDropMiniPDAposIntoleranz = true;
				return;
			elseif g_currentMission.LiveTicker ~= nil and checkPosY > 0.98 then			
				g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['liveTicker'.. moDefault.language]), 1500);
			end;			
			moSetGetGui:setOverlay(self, moSetGetGui["blank"], x, y-moGuiMiniPDAsetGet.vertical*(moGuiMiniPDAsetGet.slotsActive)+(moSetGetGui.buttonGfxHeight16*moGuiMiniPDAsetGet.zoomOutIn), moGuiMiniPDAsetGet.horizontal*(moGuiMiniPDAsetGet.slotsActive-1)+(moSetGetGui.buttonGfxWidth16*moGuiMiniPDAsetGet.zoomOutIn), moGuiMiniPDAsetGet.vertical*(moGuiMiniPDAsetGet.slotsActive-1)+(moSetGetGui.buttonGfxHeight16*moGuiMiniPDAsetGet.zoomOutIn));			
		else
			if checkPosX > 1.0 or checkPosX < 0.0 or checkPosY > 1.0 or checkPosY <= 0.01 then
				moSetGetGui:setBackgroundColor(moSetGetGui["blank"], moGuiExtras.colors["red"]);			
			elseif checkPosX > 0.998 and checkPosX <= 1.00 or checkPosX > 0.0 and checkPosX <= 0.02 then
				moSetGetGui:setBackgroundColor(moSetGetGui["blank"], moGuiExtras.colors["yellow"]);
			end;
			if x > 0.992 or y > 0.992 then
				g_currentMission:showBlinkingWarning("!! intolerance position !!", 1500);
				moSetGetGui.dragDropMiniPDAposIntoleranz = true;
				return;
			elseif g_currentMission.LiveTicker ~= nil and checkPosY > 0.98 then			
				g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['liveTicker'.. moDefault.language]), 1500);
			end;			
			moSetGetGui:setOverlay(self, moSetGetGui["blank"], x, y, moGuiMiniPDAsetGet.horizontal*(moGuiMiniPDAsetGet.slotsActive-1)+(moSetGetGui.buttonGfxWidth16*moGuiMiniPDAsetGet.zoomOutIn), moGuiMiniPDAsetGet.vertical*(moGuiMiniPDAsetGet.slotsActive-1)+(moSetGetGui.buttonGfxHeight16*moGuiMiniPDAsetGet.zoomOutIn));			
		end;		
		moSetGetGui.dragDropMiniPDAposIntoleranz = false;		
	else	
		moSetGetGui:setBackgroundColor(moSetGetGui["blank"], moGuiExtras.colors["white"]);
		moSetGetGui:setOverlay(self, moSetGetGui["blank"], x, y, moSetGetGui.buttonGfxWidth16*moGuiMiniPDAsetGet.zoomOutIn, moSetGetGui.buttonGfxHeight16*moGuiMiniPDAsetGet.zoomOutIn);
	end;	
end;

function moDrawCfg:dragDropUpdatePosSlotOpenMiniPDA(self, x, y, newRender)
	local slot = moGuiMiniPDAsetGet.slotOpenSlotNewPosTemp;
	if newRender then		
		moSetGetGui:setBackgroundColor(moSetGetGui["newPosRahmen"], moGuiExtras.colors["green"]);
		local checkPosX = x-moGuiMiniPDAsetGet.slotOpenLastWidth[slot];
		local checkPosY = y-moGuiMiniPDAsetGet.slotOpenLastHeight[slot];
		if x < 0.5 then --next update left right open Slot
			checkPosX = x;			
		end;
		local checkPosWidth = moGuiMiniPDAsetGet.slotOpenLastWidth[slot];
		local checkPosHeight = moGuiMiniPDAsetGet.slotOpenLastHeight[slot];
		if moGuiMiniPDAsetGet.slotOpenLastWidth[slot] == 0.20 and moGuiMiniPDAsetGet.slotOpenLastHeight[slot] == 0.20 then moSetGetGui:setBackgroundColor(moSetGetGui["newPosRahmen"], moGuiExtras.colors["yellow"]);end;	
		if checkPosX <= 0.0 or checkPosY <= 0.001 then moSetGetGui:setBackgroundColor(moSetGetGui["newPosRahmen"], moGuiExtras.colors["red"]);end;
		if y < 0.1 then
			g_currentMission:showBlinkingWarning("!! intolerance position !!", 1500);
			moSetGetGui.dragDropMiniPDAposIntoleranz = true;
			return;
		end;
		moSetGetGui:setOverlay(self, moSetGetGui["newPosRahmen"], checkPosX, checkPosY, checkPosWidth, checkPosHeight);
		moSetGetGui.dragDropMiniPDAposIntoleranz = false;
	else	
		moSetGetGui:setBackgroundColor(moSetGetGui["newPosRahmen"], moGuiExtras.colors["white"]);
		moSetGetGui:setOverlay(self, moSetGetGui["newPosRahmen"], x, y, moSetGetGui.buttonGfxWidth16*moGuiMiniPDAsetGet.zoomOutIn, moSetGetGui.buttonGfxHeight16*moGuiMiniPDAsetGet.zoomOutIn);
	end;
end;

function moDrawCfg:setSlotActiveValues(self)
	if moGuiMiniPDAsetGet.isKeySwitchActive then
		moSetGetGui["okayCfg"]:setPosition(moGuiMiniPDAcfgKeySwitchAreas[1][1], moGuiMiniPDAcfgKeySwitchAreas[1][3]);
		moSetGetGui["okayCfg"]:render();
	else
		moSetGetGui["noOkayCfg"]:setPosition(moGuiMiniPDAcfgKeySwitchAreas[1][1], moGuiMiniPDAcfgKeySwitchAreas[1][3]);
		moSetGetGui["noOkayCfg"]:render();
	end;
	
	--moSetGetGui["cfgVI"]:setPosition(moGuiMiniPDAcfgVIAreas[1][1], moGuiMiniPDAcfgVIAreas[1][3]);
	--moSetGetGui["cfgVI"]:render();
	--setTextColor(unpack(moGuiMiniPDAsetGet.warningColor2));
	--renderText(moGuiMiniPDAcfgVIAreas[1][1]+moSetGetGui.buttonGfxWidth8*moSetGetGui.pdaVI.zoomOutInVI+0.002, moGuiMiniPDAcfgVIAreas[1][3]+0.002, 0.015, "VI Settings");
	--setTextColor(1, 1, 1, 1);
	
	if moGuiMiniPDAsetGet.slotsActive ~= 0 then
		if not moSetGetGui.dragDropMiniPDApos then				
			moSetGetGui:setBackgroundColor(moSetGetGui["blank"], moGuiExtras.colors["green"]);
			moSetGetGui:setOverlay(self, moSetGetGui["blank"], moGuiMiniPDAcfgDisplayAreas[1][1], moGuiMiniPDAcfgDisplayAreas[1][3], moGuiMiniPDAcfgDisplayAreas[1][2]-moGuiMiniPDAcfgDisplayAreas[1][1], moGuiMiniPDAcfgDisplayAreas[1][4]-moGuiMiniPDAcfgDisplayAreas[1][3]);
			moSetGetGui["blank"]:render();
		end;
		if moGuiMiniPDAsetGet.warningBlinkTempMouse <= moGuiMiniPDAsetGet.warningBlinkTime then --warningBlinkTime, warningBlinkTempMouse
			moGuiMiniPDAsetGet.warningBlinkTempMouse = moGuiMiniPDAsetGet.warningBlinkTempMouse+1
			moSetGetGui:setOverlay(self, moSetGetGui["mouse6"], moGuiMiniPDAareas.clickNewPosSlotsArea[1], moGuiMiniPDAareas.clickNewPosSlotsArea[3], moSetGetGui.buttonGfxWidth10*moGuiMiniPDAsetGet.zoomOutInTemp, moSetGetGui.buttonGfxHeight10*moGuiMiniPDAsetGet.zoomOutInTemp);
			moSetGetGui["mouse6"]:render();			
		else
			moGuiMiniPDAsetGet.warningBlinkTempMouse = moGuiMiniPDAsetGet.warningBlinkTempMouse+1
			if moGuiMiniPDAsetGet.warningBlinkTempMouse >= moGuiMiniPDAsetGet.warningBlinkTime*2 then moGuiMiniPDAsetGet.warningBlinkTempMouse = 0;end;
		end;
	end;	
	for a=1, moGuiMiniPDAsetGet.slotsMax do
		if moGuiMiniPDAcfgAreasValues[a].isActive then
			moSetGetGui["miniPDAslotCfg"]:setPosition(moGuiMiniPDAcfgSlotAreas[a][1], moGuiMiniPDAcfgSlotAreas[a][3]);
			moSetGetGui["miniPDAslotCfg"]:render();
			if moGuiMiniPDAcfgAreasValues[a].isSlotCfg == "disable" then
				moSetGetGui["notReadyCfg"]:setPosition(moGuiMiniPDAcfgSlotAreas[a][1], moGuiMiniPDAcfgSlotAreas[a][3])
				moSetGetGui["notReadyCfg"]:render();
			elseif moGuiMiniPDAcfgAreasValues[a].isSlotCfg and moGuiMiniPDAsetGet.cfgSlotOpen == a then
				moSetGetGui["okayCfg"]:setPosition(moGuiMiniPDAcfgSlotAreas[a][1], moGuiMiniPDAcfgSlotAreas[a][3])
				moSetGetGui["okayCfg"]:render();
			end;
		end;
	end;
	if moGuiMiniPDAsetGet.cfgSlotOpen ~= 0 and moGuiMiniPDAcfgAreasValues[moGuiMiniPDAsetGet.cfgSlotOpen].isSlotCfg then
		local slot = moGuiMiniPDAsetGet.cfgSlotOpen;
		moSetGetGui["miniPDAsettings"]:setPosition(moGuiMiniPDAsetGet.posXcfgHud, moGuiMiniPDAsetGet.posYcfgHud-moSetGetGui.buttonGfxHeight16*moGuiMiniPDAsetGet.zoomOutInTemp);
		moSetGetGui["miniPDAsettings"]:render();
		if tonumber(slot) == 8 or tonumber(slot) == 9 then
			if moGuiMiniPDAsetGet.combiBgaSilo then
				moSetGetGui["okayCfg"]:setPosition(moGuiMiniPDAcfgCombiBgaSiloAreas[slot][1], moGuiMiniPDAcfgCombiBgaSiloAreas[slot][3]);
				moSetGetGui["okayCfg"]:render();
			else
				moSetGetGui["noOkayCfg"]:setPosition(moGuiMiniPDAcfgCombiBgaSiloAreas[slot][1], moGuiMiniPDAcfgCombiBgaSiloAreas[slot][3]);
				moSetGetGui["noOkayCfg"]:render();
			end;
		end;
		if moGuiMiniPDAcfgAreasValues[slot].isOpenSlotNewPos == "disable" then
			moSetGetGui["notReadyCfg"]:setPosition(moGuiMiniPDAcfgOpenSlotNewPosAreas[1], moGuiMiniPDAcfgOpenSlotNewPosAreas[3]);
			moSetGetGui["notReadyCfg"]:render();
		elseif moGuiMiniPDAcfgAreasValues[slot].isOpenSlotNewPos then									
			moSetGetGui["okayCfg"]:setPosition(moGuiMiniPDAcfgOpenSlotNewPosAreas[1], moGuiMiniPDAcfgOpenSlotNewPosAreas[3]);
			moSetGetGui["okayCfg"]:render();
		else									
			moSetGetGui["noOkayCfg"]:setPosition(moGuiMiniPDAcfgOpenSlotNewPosAreas[1], moGuiMiniPDAcfgOpenSlotNewPosAreas[3]);
			moSetGetGui["noOkayCfg"]:render();
		end;		
		if moGuiMiniPDAcfgAreasValues[slot].isWarning == "disable" then
			moSetGetGui["notReadyCfg"]:setPosition(moGuiMiniPDAcfgWarningAreas[1], moGuiMiniPDAcfgWarningAreas[3])
			moSetGetGui["notReadyCfg"]:render();
		elseif moGuiMiniPDAcfgAreasValues[slot].isWarning then									
			moSetGetGui["okayCfg"]:setPosition(moGuiMiniPDAcfgWarningAreas[1], moGuiMiniPDAcfgWarningAreas[3])
			moSetGetGui["okayCfg"]:render();
		else									
			moSetGetGui["noOkayCfg"]:setPosition(moGuiMiniPDAcfgWarningAreas[1], moGuiMiniPDAcfgWarningAreas[3])
			moSetGetGui["noOkayCfg"]:render();
		end;
		if moGuiMiniPDAcfgAreasValues[slot].isCloseOpenHud == "disable" then
			moSetGetGui["notReadyCfg"]:setPosition(moGuiMiniPDAcfgCloseOpenHudAreas[1], moGuiMiniPDAcfgCloseOpenHudAreas[3])
			moSetGetGui["notReadyCfg"]:render();
		elseif moGuiMiniPDAcfgAreasValues[slot].isCloseOpenHud then									
			moSetGetGui["okayCfg"]:setPosition(moGuiMiniPDAcfgCloseOpenHudAreas[1], moGuiMiniPDAcfgCloseOpenHudAreas[3])
			moSetGetGui["okayCfg"]:render();
		else									
			moSetGetGui["noOkayCfg"]:setPosition(moGuiMiniPDAcfgCloseOpenHudAreas[1], moGuiMiniPDAcfgCloseOpenHudAreas[3])
			moSetGetGui["noOkayCfg"]:render();
		end;
		if moGuiMiniPDAcfgAreasValues[slot].isCloseOpenForeignHuds == "disable" then
			moSetGetGui["notReadyCfg"]:setPosition(moGuiMiniPDAcfgCloseOpenForeignHudsAreas[1], moGuiMiniPDAcfgCloseOpenForeignHudsAreas[3])
			moSetGetGui["notReadyCfg"]:render();
		elseif moGuiMiniPDAcfgAreasValues[slot].isCloseOpenForeignHuds then									
			moSetGetGui["okayCfg"]:setPosition(moGuiMiniPDAcfgCloseOpenForeignHudsAreas[1], moGuiMiniPDAcfgCloseOpenForeignHudsAreas[3])
			moSetGetGui["okayCfg"]:render();
		else									
			moSetGetGui["noOkayCfg"]:setPosition(moGuiMiniPDAcfgCloseOpenForeignHudsAreas[1], moGuiMiniPDAcfgCloseOpenForeignHudsAreas[3])
			moSetGetGui["noOkayCfg"]:render();
		end;						
	end;	
end;