moSetGetShopMods = {};

function moSetGetShopMods:setUpdateShopMod(self)	
	if moDefaultPlaceableStation.mapShopSearch <= 0 then return;end;
	moShopMods = {};
	for a=1, moDefaultPlaceableStation.mapShopSearch do
		local shopName = moDefaultPlaceableStation.mapShopName[a];
		local shopMod = moDefaultPlaceableStation.mapShopMod[a];
		local obj = moDefaultPlaceableStation.mapShopStatus[a];
		moShopMods[a] = {};
		moShopMods[a].acceptedFillTypes = {};
		moShopMods[a].descName = {};
		moShopMods[a].fruitName = {};
		moShopMods[a].price = {};		
		local textName = shopName;						
		local lengthName = string.len(textName);				 
		if lengthName < 4 then
			textName = "**".. textName.. "**"
			lengthName = lengthName+4				
		end;
		if lengthName < 6 then
			textName = "*".. textName.. "*"
			lengthName = lengthName+2				
		end;
		moShopMods[a].modTypName = shopMod;
		moShopMods[a].station = shopName;
		moShopMods[a].stationName = textName;
		moShopMods[a].stationNameLength = lengthName+3;
		if shopMod == "viehmarkt" then								
			local fillTypes = "";
			for k, v in pairs(obj.fillTypes) do				
				local desc = Fillable.fillTypeIndexToDesc[v];				
				if desc ~= nil then					
					moShopMods[a].acceptedFillTypes[k] = desc;					
					moShopMods[a].descName[k] = desc.name;
					moShopMods[a].fruitName[k] = moFillTypes[desc.index].fruitName;
					local difficultyMultiplier = math.max((g_currentMission.missionStats.difficulty - 3)*2, 1); --marhu error, not correct 
					local price = desc.pricePerLiter*obj.priceMultipliers[desc.index]*difficultyMultiplier;
					local tempPrice = string.format("%.1f", Utils.getNoNil(price, 0));
					moShopMods[a].price[k] = tonumber(tempPrice);					
				end
			end;				
		end;
	end;
	print(Eisbearg___AIO___GenericScriptPack.DebugExtension:tableToString(moShopMods));
end;

function moSetGetShopMods:setUpdateShopModOld(self)	
	if moDefaultPlaceableStation.mapShopSearch <= 0 then return;end;
	moShopMods = {};
	for a=1, moDefaultPlaceableStation.mapShopSearch do
		local shopName = moDefaultPlaceableStation.mapShopName[a];
		local shopMod = moDefaultPlaceableStation.mapShopMod[a];
		local obj = moDefaultPlaceableStation.mapShopStatus[a];
		moShopMods[shopMod] = {};
		moShopMods[shopMod].acceptedFillTypes = {};
		moShopMods[shopMod].descName = {};
		moShopMods[shopMod].fruitName = {};
		moShopMods[shopMod].price = {};		
		local textName = shopName;						
		local lengthName = string.len(textName);				 
		if lengthName < 4 then
			textName = "**".. textName.. "**"
			lengthName = lengthName+4				
		end;
		if lengthName < 6 then
			textName = "*".. textName.. "*"
			lengthName = lengthName+2				
		end;
		moShopMods[shopMod].station = shopName;
		moShopMods[shopMod].stationName = textName;
		moShopMods[shopMod].stationNameLength = lengthName+3;
		if shopMod == "viehmarkt" then								
			local fillTypes = "";
			for k, v in pairs(obj.fillTypes) do				
				local desc = Fillable.fillTypeIndexToDesc[v];				
				if desc ~= nil then					
					moShopMods[shopMod].acceptedFillTypes[k] = desc;					
					moShopMods[shopMod].descName[k] = desc.name;
					moShopMods[shopMod].fruitName[k] = moFillTypes[desc.index].fruitName;
					local difficultyMultiplier = math.max((g_currentMission.missionStats.difficulty - 3)*2, 1); --marhu error, not correct 
					local price = desc.pricePerLiter*obj.priceMultipliers[desc.index]*difficultyMultiplier;
					local tempPrice = string.format("%.1f", Utils.getNoNil(price, 0));
					moShopMods[shopMod].price[k] = tonumber(tempPrice);					
				end
			end;				
		end;
	end;
	print(Eisbearg___AIO___GenericScriptPack.DebugExtension:tableToString(moShopMods));
end;